# Beta and experimental features

Sourcegraph often beta tests major features before we make them generally available. 

Exposing beta and experimental features gives you an opportunity to try our newest features sooner.

In return, your feedback helps us make sure that our new features are reliable and useful, and we appreciate any and all feedback you want to provide. You can [file an issue](https://github.com/sourcegraph/sourcegraph/issues/new/choose), email it directly to [feedback@sourcegraph.com](mailto:feedback@sourcegraph.com), or use the in-app feedback modal. 

## **Both** beta and experimental features

For both features labeled `Beta` and those labeled `Experimental`, Sourcegraph wants to be transparent that:  

- The feature is undergoing active development and your [feedback](mailto:feedback@sourcegraph.com) is especially appreciated
- The feature may have bugs
- The feature may be changed, deprecated, or removed
- The feature is excluded from our [Support SLAs](https://handbook.sourcegraph.com/support#slas)
- The feature may have an additional cost to use once it becomes generally available 
- Any documentation for the feature will explicitly note the feature is in beta or experimental mode

## Experimental features

If a feature is labeled `Experimental`, this specifically means: 

- The feature may be primarily supported by the product engineering team rather than our customer support team
- The feature may have limited support and no documentation in the Sourcegraph docs
- The feature will have to be deliberately enabled

## Beta features

If a feature is labeled `Beta`, this specifically means: 

- The feature will have documentation on docs.sourcegraph.com
- The feature will be primarily supported by the customer support team
- The feature may require intentional setup, or it may be widely available to all users by default 
