# Migration notes for Sourcegraph 3.11+

### Management console removal

In Sourcegraph v3.11, the management console has been removed and all of its configuration properties have been moved into the **Site admin** > **Configuration** page. Upon upgrading, your management console configuration will automatically be merged into your site configuration.

### Users of SITE_CONFIG_FILE and CRITICAL_CONFIG_FILE

If you are making use of `SITE_CONFIG_FILE` or `CRITICAL_CONFIG_FILE` environment variables please:

1. Simply copy all properties from `CRITICAL_CONFIG_FILE` and paste them into `SITE_CONFIG_FILE`.
2. Upgrade to the latest Sourcegraph version.
3. Delete and remove the `CRITICAL_CONFIG_FILE`, as it will no longer be used.

If you have already upgraded without doing the above, simply copy the merged configuration from https://sourcegraph.example.com/site-admin/configuration back into your `SITE_CONFIG_FILE`, delete and remove the `CRITICAL_CONFIG_FILE`.

### Downgrading

If you intend to downgrade from v3.11 back to v3.10 or earlier, please note that you will need to restore your management console configuration after downgrading. To safely downgrade, please perform the following steps:

1. Make a copy of your site configuration.
2. Change the Docker image tag(s) to 3.10 or earlier and restart the server.
3. Visit the management console, your critical configuration will be just `{"migrated": true}`.
4. Copy the relevant properties from your site configuration into the management console.

If you have any questions or concerns, please reach out to us (support@sourcegraph.com).
