# Observability

<p class="lead">
A key pillar of production readiness is the ability to observe, monitor, and analyze the health and state of the system.
Sourcegraph is designed, and ships with, a number of observability tools and capabilities to meet enterprise production readiness criteria.
</p>

<div class="getting-started">
  <a href="metrics" class="btn" alt="Run through the Quickstart guide">
   <span>Metrics and dashboards</span>
   </br>
   Learn about the metrics and dashboards provided out-of-the-box.
  </a>

  <a href="alerting" class="btn" alt="Set up alerting">
   <span>Alerting</span>
   </br>
   Receive notifications about the health of your Sourcegraph deployment.
  </a>

  <a href="troubleshooting" class="btn" alt="Set up alerting">
   <span>Troubleshooting</span>
   </br>
   Investigate a specific production issue with our troubleshooting guide.
  </a>
</div>

## Guides

* [Metrics and dashboards](metrics.md)
* [Alerting](./alerting.md)
* [Tracing](./tracing.md)
* [Logs](./logs.md)
* [Health checks](./health_checks.md)
* [Troubleshooting guide](troubleshooting.md)
* [Monitoring guide](../how-to/monitoring-guide.md)

## Reference

* [Dashboards reference](./dashboards.md)
* [Alert solutions](./alert_solutions.md)

## Support

For help configuring observability on your Sourcegraph instance, use our [public issue tracker](https://github.com/sourcegraph/issues/issues).
