# CLI

<p class="subtitle">Interact with Sourcegraph from the command line</p>

<p class="lead">
  <code>src</code> is a command line interface to Sourcegraph that allows you to <a href="../code_search">search code</a> from your terminal, <a href="../batch_changes">create and apply batch changes</a>, and <a href="../admin">manage and administrate repositories, users, and more</a>.
</p>

<div class="cta-group">
  <a class="btn btn-primary" href="quickstart">★ Quickstart</a>
</div>

## Getting started

<div class="getting-started">
  <a href="quickstart" class="btn" alt="Run through the Quickstart guide">
    <span>New to <code>src</code>?</span>
    <br />
    Run through the <b>quickstart guide</b> and set up <code>src</code> in minutes.
  </a>

  <a href="references" class="btn" alt="Read the src reference">
    <span>Command reference</span>
    <br />
    Check the commands available in <code>src</code> and their flags.
  </a>

  <a href="../batch_changes/quickstart" class="btn" alt="Create a batch change">
    <span>Create a batch change</span>
    <br />
    <code>src</code> is the gateway to Sourcegraph's batch change functionality: find out how to create a batch change with it in less than 10 minutes.
  </a>
</div>

## Explanations

- [Environment variables](explanations/env.md)
- [Windows support](explanations/windows.md)

## How-tos

- [Creating an access token](how-tos/creating_an_access_token.md)

## References

- [Command reference](references/index.md)
