# Differences between Sourcegraph Cloud and Sourcegraph self-hosted

## What is Sourcegraph self-hosted, and who should choose it?

Sourcegraph self-hosted allows users to deploy and manage their own instances of Sourcegraph. Each instance allows an admin to connect code repositories and then invite team members to collaborate within the instance. With this version of Sourcegraph, code never leaves the user’s environment (it stays on-premises). 

Sourcegraph self-hosted offers both [Free, Team, and Enterprise tiers](https://about.sourcegraph.com/pricing). It is the primary Sourcegraph solution our customers use today and is the best choice for teams and enterprises working on a codebase together. The Enterprise tier provides advanced security functionality, robust user management, private code sharing, and features such as Batch Changes which allow teams to make code changes at scale. 

Installation instructions for self-hosted Sourcegraph [can be found here](https://docs.sourcegraph.com/admin/install). It is free to install and comes with a 30-day enterprise trial. [Speak to a product specialist](https://about.sourcegraph.com/contact/sales) to learn more. 

We also offer managed Sourcegraph instances; more details can [be found here](https://docs.sourcegraph.com/admin/install/managed).

## What is Sourcegraph Cloud, and who should choose it?

Sourcegraph Cloud is a newly-released cloud version of Sourcegraph, which can be accessed at sourcegraph.com. It allows users to:
- Search an index of over 1 million open source repositories
- Connect to and search their own public repositories
- Connect to and search their own private repositories (Public Beta)

Sourcegraph Cloud offers the same core Code Search experience for private and public code as Sourcegraph self-hosted, but it does not support enterprise features such as user management, SAML integration, and batch changes. It is intended for personal use.

Sourcegraph Cloud is a great choice for individuals who would like to search their own repositories without deploying Sourcegraph themselves. It also allows individuals to easily access our index of over 1 million open source repositories.
