# Getting Started on Sourcegraph Cloud

Are you new to Sourcegraph Cloud? This is your place to start. 

[Sourcegraph Cloud](https://sourcegraph.com/search) lets you search across your code from GitHub.com or GitLab.com, and across any open-source project on GitHub.com or Gitlab.com. Sourcegraph Cloud is in Public Beta, allowing any individual to sign-up, connect personal repositories, and search across personal code. 

## Getting Started
Getting started with Sourcegraph Cloud takes less than one minute. Follow the below steps to get started
1. Sign up for an [account on Sourcegraph Cloud](https://sourcegraph.com/sign-up). After sign-up, you will be guided through the next two steps
1. Connect a code host using your OAuth flow. Sourcegraph Cloud natively supports Github.com and Gitlab.com repositories. 
1. Next, [add your repositories to Sourcegraph](https://learn.sourcegraph.com/how-to-add-private-code-repositories-to-sourcegraph). Sourcegraph respects code host permissions, so you should only see repositories which you have permission to on the code host you connected. 
1. Try out your first search! Sourcegraph search is incredibly powerful and it may take some time to fully understand the power. Don't worry, start with [three ways to search Sourcegraph](https://learn.sourcegraph.com/three-ways-to-search-video).

Are you stuck along the way? Please do not hesitate to reach out to our [support team](mailto:support@sourcegraph.com).

## Explanations and how-tos

- [Adding repositories to Sourcegraph Cloud](../code_search/how-to/adding_repositories_to_cloud.md)
- [Searching across repositories you’ve added to Sourcegraph Cloud with search contexts](../code_search/how-to/searching_with_search_contexts.md)
- [Who can see your code on Sourcegraph Cloud](../code_search/explanations/code_visibility_on_sourcegraph_cloud.md)
- [FAQ](../code_search/explanations/sourcegraph_cloud.md)
