# Code monitoring

<style>

.markdown-body h2 {
  margin-top: 2em;
}

.markdown-body ul {
  list-style:none;
  padding-left: 1em;
}

.markdown-body ul li {
  margin: 0.5em 0;
}

.markdown-body ul li:before {
  content: '';
  display: inline-block;
  height: 1.2em;
  width: 1em;
  background-size: contain;
  background-repeat: no-repeat;
  background-image: url(code_monitoring/file-icon.svg);
  margin-right: 0.5em;
  margin-bottom: -0.29em;
}

body.theme-dark .markdown-body ul li:before {
  filter: invert(50%);
}

</style>

<p class="subtitle">Keep on top of events in your codebase</p>

<p class="lead">
Watch your code with code monitors and trigger actions to run automatically in response to events.
</p>

## Getting started

<div class="getting-started">
  <a href="quickstart" class="btn" alt="Run through the Quickstart guide">
   <span>New to code monitoring?</span>
   </br>
   Use our <b>quickstart guide</b> to create your first code monitor.
  </a>


  <a href="how-tos/starting_points" class="btn" alt="Starting points for code monitors">
   <span>Starting points</span>
   </br>
   Use our starting points to jump-start your code monitoring.
  </a>
</div>

## Explanations

- [Core concepts](explanations/core_concepts.md)
- [Best practices](explanations/best_practices.md)
- [Starting points and ideas](how-tos/starting_points.md)

## Questions & Feedback

We want to hear your feedback! [Share your thoughts](mailto:feedback@sourcegraph.com)
