# Integrations

Sourcegraph integrates with your other tools to help you search, navigate, and review your code.

- [Browser extension](browser_extension.md): go-to-definitions and hovers in your code host and code reviews
  - [Google Workspace (formerly known as G Suite) and Chrome Enterprise](google_workspace.md)
- Code hosts
  - [GitHub](github.md)
  - [GitLab](gitlab.md)
  - [Bitbucket Cloud](bitbucket_cloud.md)
  - [Bitbucket Server](bitbucket_server.md)
  - [Phabricator](phabricator.md)
  - [AWS CodeCommit](aws_codecommit.md)
  - [Gitolite](gitolite.md)
  - [Other Git repository hosts](../admin/external_service/other.md)
- Other services
  - [Codecov](https://sourcegraph.com/extensions/sourcegraph/codecov)
  - [Datadog](https://sourcegraph.com/extensions/sourcegraph/datadog-metrics)
  - [LightStep](lightstep.md)
  - [View all "External services" extensions](https://sourcegraph.com/extensions?query=category%3A%22External+services%22)
- [Editor plugins](editor.md): jump to Sourcegraph from your editor
- [Search shortcuts](browser_search_engine.md): quickly search from your browser
- [GraphQL API](../api/graphql/index.md): create custom tools using Sourcegraph data

![GitHub pull request integration](img/GitHubDiff.png)
