package authz

// Below is a high-level diagram of the PermsSyncer.
//	┌──────────────────────────────────────────┐
//	│repo-updater                              │
//	│                                          │
//	│┌────────────────────────────────────────┐│
//	││PermsSyncer                             ││
//	││                                        ││
//	││                ┌─────┐                 ││
//	││         ┌──────│ Run │────┐            ││
//	││         │      └─────┘    │            ││
//	││         ▼                 ▼            ││
//	││  ┌─────────────┐     ┌─────────┐       ││
//	││  │ runSchedule │     │ runSync │       ││
//	││  └─────────────┘     └─────────┘       ││
//	││         │                 ▲            ││
//	││          enqueue           dequeue     ││
//	││         │     ┌───────┐   │            ││
//	││          ─ ─ ▶│ queue │─ ─             ││
//	││               └───────┘                ││
//	││                   ▲                    ││
//	││           ┌ ─ ─ ─ ┴ ─ ─ ─ ─ ┐          ││
//	││                enqueue                 ││
//	││           │                 │          ││
//	││   ┌───────────────┐ ┌───────────────┐  ││
//	││   │ ScheduleUsers │ │ ScheduleRepos │  ││
//	││   └───────────────┘ └───────────────┘  ││
//	│└───────────▲─────────────────▲──────────┘│
//	│            └───────┬─────────┘           │
//	│                    │                     │
//	│            ┌ ─ ─ ─ ─ ─ ─ ─ ┐             │
//	│              RPC handlers                │
//	│            └ ─ ─ ─ ─ ─ ─ ─ ┘             │
//	└──────────────────────────────────────────┘
