### Plan

#### Cloud

We plan to complete all functional changes necessary to have individual Sourcegraphers (teammates) be able to add public code on sourcegraph.com. This is part of our first Cloud milestone as documented in [our team page](https://about.sourcegraph.com/handbook/engineering/cloud). All work items on this goal are labeled with `RFC-211` and `team/cloud/milestone-1`.

#### Security

For Cloud Milestone 1, in addition to the functional changes above, we need to complete the necessary work to store relevant secrets securely (i.e. encrypted). Even for public code, it's important that we store teammates access tokens in an encrypted fashion. All work items on this goal are labeled with `RFC-214` and `team/cloud/milestone-1`.

Additionally, we have some miscellaneous security bugs to address, marked appropriately with 🔒 in the Work section below.

#### Backend infrastructure

**RFC 167: Generate new licenses with versioned tags** is small enough and we can get the benefit of new licenses already being versioned, minimising the migration effort needed by the sales team later. The remainder of the work in RFC-167 accounts for roughly 2 weeks and we tentatively plan to take it on in the next cycle.

We'll also work on a number of customer issues and tech-debt, marked appropriately with 👩  and 🧶 in the Work section below.

### Availability

**Period**: 23rd of September until the 6th of October (10 working days)

If you have planned unavailability this iteration (e.g., vacation), you can note that here.

- @ryanslade: 24th of September (1d) 
- @daxmc99: 28th of September (1d)
- @unknwon: 1st until 8th of October (4d)

### Work

<!-- BEGIN WORK -->
<!-- BEGIN ASSIGNEE: asdine -->
@asdine: __7.00d__


Completed: __7.00d__
- [x] (🏁 442 days ago) https://github.com/sourcegraph/sourcegraph/issues/13401 (PRs: ~[#14094](https://github.com/sourcegraph/sourcegraph/pull/14094)~) __0.50d__ 🧶   🏳️ [Cloud 2020-09-23](https://github.com/sourcegraph/sourcegraph/milestone/50)
- [x] (🏁 435 days ago) https://github.com/sourcegraph/sourcegraph/pull/14098 
- [x] (🏁 401 days ago) https://github.com/sourcegraph/sourcegraph/issues/14163  __6.50d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: daxmc99 -->
@daxmc99: __1.00d__


Completed: __1.00d__
- [x] (🏁 288 days ago) https://github.com/sourcegraph/sourcegraph/issues/14166  __1.00d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: flying-robot -->
@flying-robot: __3.00d__


Completed: __3.00d__
- [x] (🏁 430 days ago) https://github.com/sourcegraph/sourcegraph/issues/13956 (PRs: ~[#14370](https://github.com/sourcegraph/sourcegraph/pull/14370)~) __2.00d__   🏳️ [Cloud 2020-09-23](https://github.com/sourcegraph/sourcegraph/milestone/50)
- [x] (🏁 288 days ago) https://github.com/sourcegraph/sourcegraph/issues/14166  __1.00d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: ryanslade -->
@ryanslade: __7.50d__


Completed: __7.50d__
- [x] (🏁 442 days ago) https://github.com/sourcegraph/sourcegraph/pull/14095 
- [x] (🏁 435 days ago) https://github.com/sourcegraph/sourcegraph/pull/14305 
- [x] (🏁 434 days ago) https://github.com/sourcegraph/sourcegraph/pull/14334 
- [x] (🏁 433 days ago) https://github.com/sourcegraph/sourcegraph/pull/14372 
- [x] (🏁 433 days ago) https://github.com/sourcegraph/sourcegraph/pull/14375 
- [x] (🏁 429 days ago) https://github.com/sourcegraph/sourcegraph/pull/14376 
- [x] (🏁 429 days ago) https://github.com/sourcegraph/sourcegraph/pull/14436 
- [x] (🏁 401 days ago) https://github.com/sourcegraph/sourcegraph/issues/14163  __6.50d__
- [x] (🏁 288 days ago) https://github.com/sourcegraph/sourcegraph/issues/14166  __1.00d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: tsenart -->
@tsenart


Completed
- [x] (🏁 432 days ago) https://github.com/sourcegraph/sourcegraph/pull/14373 🐛
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: unknwon -->
@unknwon: __2.00d__


Completed: __2.00d__
- [x] (🏁 441 days ago) https://github.com/sourcegraph/sourcegraph/issues/14046  __0.50d__   🏳️ [Cloud 2020-09-23](https://github.com/sourcegraph/sourcegraph/milestone/50)
- [x] (🏁 288 days ago) https://github.com/sourcegraph/sourcegraph/issues/14166  __1.50d__
<!-- END ASSIGNEE -->
<!-- END WORK -->

#### Legend

- 👩 Customer issue
- 🐛 Bug
- 🧶 Technical debt
- 🎩 Quality of life
- 🛠️ [Roadmap](https://docs.google.com/document/d/1cBsE9801DcBF9chZyMnxRdolqM_1c2pPyGQz15QAvYI/edit#heading=h.5nwl5fv52ess)
- 🕵️ [Spike](https://en.wikipedia.org/wiki/Spike_(software_development))
- 🔒 Security issue
- :shipit: Pull Request
